"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vario_1 = require("../vario");
var person_1 = require("./person");
var DemoApp = (function () {
    function DemoApp() {
        this.title = "Demo";
        this.users = [];
    }
    DemoApp.prototype.loadUsers = function () {
        this.users.push(new person_1.Person({
            name: "John", age: 38,
            emails: ["john@mail.com"],
            children: [
                new person_1.Person({ name: "Billy" }),
                new person_1.Person({ name: "Barry" }),
                new person_1.Person({ name: "Steve" }),
            ],
        }));
        this.users.push(new person_1.Person({
            name: "Kevin", age: 27,
            emails: ["kevin@mail.com"],
            children: [
                new person_1.Person({ name: "Britney" }),
            ],
        }));
    };
    __decorate([
        vario_1.tran,
        __metadata("design:type", String)
    ], DemoApp.prototype, "title", void 0);
    __decorate([
        vario_1.tran,
        __metadata("design:type", Array)
    ], DemoApp.prototype, "users", void 0);
    __decorate([
        vario_1.tran,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], DemoApp.prototype, "loadUsers", null);
    DemoApp = __decorate([
        vario_1.tran
    ], DemoApp);
    return DemoApp;
}());
exports.DemoApp = DemoApp;
var DemoAppView = (function () {
    function DemoAppView(model) {
        this.userFilter = "Jo";
        this.model = model;
    }
    DemoAppView.prototype.filteredUsers = function () {
        var m = this.model;
        var result = m.users;
        if (this.userFilter.length > 0) {
            result = [];
            for (var _i = 0, _a = m.users; _i < _a.length; _i++) {
                var x = _a[_i];
                if (x.name && x.name.indexOf(this.userFilter) === 0)
                    result.push(x);
            }
        }
        return result;
    };
    DemoAppView.prototype.render = function () {
        var r = [];
        r.push("---");
        r.push("Filter: " + this.userFilter);
        var a = this.filteredUsers();
        for (var _i = 0, a_1 = a; _i < a_1.length; _i++) {
            var x = a_1[_i];
            var childNames = x.children.map(function (child) { return child.name; });
            r.push(x.name + "'s children: " + childNames.join(", "));
        }
        r.push("---");
        return r;
    };
    DemoAppView.prototype.print = function () {
        this.render().forEach(function (x) { return console.log(x); });
    };
    __decorate([
        vario_1.tran,
        __metadata("design:type", String)
    ], DemoAppView.prototype, "userFilter", void 0);
    __decorate([
        vario_1.cache,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Array)
    ], DemoAppView.prototype, "filteredUsers", null);
    __decorate([
        vario_1.cache,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", Array)
    ], DemoAppView.prototype, "render", null);
    __decorate([
        vario_1.cache,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], DemoAppView.prototype, "print", null);
    DemoAppView = __decorate([
        vario_1.tran,
        __metadata("design:paramtypes", [DemoApp])
    ], DemoAppView);
    return DemoAppView;
}());
exports.DemoAppView = DemoAppView;
function sample() {
    var app = new DemoApp();
    var view = new DemoAppView(app);
    app.loadUsers();
    vario_1.keepfresh(true, view.print);
    var t1 = new vario_1.Transaction("t1");
    t1.run(function () {
        var daddy = app.users[0];
        daddy.age += 2;
        daddy.name = "John Smith";
        daddy.children[0].name = "Barry Smith";
        daddy.children[1].name = "William Smith";
        daddy.children[2].name = "Steven Smith";
    });
    t1.run(function () {
        var daddy = app.users[0];
        daddy.age += 5;
        view.userFilter = "";
        if (daddy.emails)
            daddy.emails[0] = "daddy@mail.com";
        var x = daddy.children[1];
        x.parent = null;
        x.parent = daddy;
    });
    t1.commit();
    try {
        var daddy = app.users[0];
        if (daddy.emails)
            daddy.emails.push("dad@mail.com");
        else
            daddy.children[1].name = "Billy Smithy";
    }
    catch (e) {
        console.log("Expected: " + e);
    }
    vario_1.keepfresh(false, view.print);
}
exports.sample = sample;
//# sourceMappingURL=main.js.map