"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Transaction = (function () {
    function Transaction(hint) {
        this.id = 0;
        this._snapshot = 0;
        this.changeset = new Map();
        this.pending = 0;
        this.sealed = false;
        this._error = undefined;
        this.resultPromise = undefined;
        this.resultResolve = function () { };
        this.resultReject = function () { };
        this.conflicts = undefined;
        this.refreshing = [];
        this.id = ++Transaction.id;
        this.hint = (hint || "noname").replace("{VARIO_TRANSACTION}", "" + this.id);
    }
    Object.defineProperty(Transaction.prototype, "snapshot", {
        get: function () { return this._snapshot; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Transaction.prototype, "error", {
        get: function () { return this._error; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Transaction, "current", {
        get: function () {
            return Ctx.transaction;
        },
        enumerable: true,
        configurable: true
    });
    Transaction.prototype.run = function (func) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (this.sealed && Ctx.transaction !== this)
            throw new Error("E601: cannot run sealed transaction");
        return this._run.apply(this, [func].concat(args));
    };
    Transaction.prototype.wrap = function (func) {
        return Transaction._wrap(this, Ctx.caching, true, true, func);
    };
    Transaction.prototype.commit = function () {
        if (this.pending > 0)
            throw new Error("E602: cannot commit transaction having pending async operations");
        if (this._error)
            throw new Error("E603: cannot commit discarded transaction: " + this._error);
        this.sealToCommit();
    };
    Transaction.prototype.sealToCommit = function () {
        if (!this.sealed)
            this.run(Transaction.seal, this);
        return this;
    };
    Transaction.prototype.discard = function (error) {
        if (error === void 0) { error = "transaction discarded"; }
        if (!this._error)
            this._error = error;
        if (!this.sealed)
            this.run(Transaction.seal, this);
        return this;
    };
    Transaction.prototype.waitForFinish = function () {
        return this.acquirePromise();
    };
    Transaction.prototype.finished = function () {
        return this.sealed && this.pending === 0;
    };
    Transaction.prototype.undo = function () {
        throw new Error("not implemented");
    };
    Transaction.prototype.redo = function () {
        throw new Error("not implemented");
    };
    Transaction.run = function (hint, func) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        var t = Ctx.transaction || new Transaction(hint);
        var result;
        try {
            result = t.run.apply(t, [func].concat(args));
            t.sealAndRethrowErrorIfNeeded();
        }
        catch (error) {
            t.discard(error);
            throw error;
        }
        return result;
    };
    Transaction.runAsync = function (hint, func) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var t, result, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        t = Ctx.transaction || new Transaction(hint);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, t.run.apply(t, [func].concat(args))];
                    case 2:
                        result = _a.sent();
                        t.sealAndRethrowErrorIfNeeded();
                        return [3, 4];
                    case 3:
                        error_1 = _a.sent();
                        t.discard(error_1);
                        throw error_1;
                    case 4: return [2, result];
                }
            });
        });
    };
    Transaction.prototype._run = function (func) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var outer = Ctx.transaction;
        var result;
        try {
            this.pending++;
            Ctx.transaction = this;
            result = func.apply(void 0, args);
            if (this.sealed && this.pending === 1 && !this._error)
                if (this.checkConflictsResolved() && this.pending === 1 && !this._error)
                    this.freezeChangeset();
        }
        catch (e) {
            this._error = this._error || e;
            throw e;
        }
        finally {
            if (this.sealed && this.pending === 1)
                !this._error ? this.performCommit() : this.performDiscard();
            this.pending--;
            Ctx.transaction = outer;
        }
        if (this.finished())
            for (var _a = 0, _b = this.refreshing; _a < _b.length; _a++) {
                var x = _b[_a];
                x.ensureFresh();
            }
        return result;
    };
    Transaction.prototype.sealAndRethrowErrorIfNeeded = function () {
        if (!Ctx.transaction)
            this.sealToCommit();
        if (this.finished() && this._error)
            throw this._error;
    };
    Transaction.seal = function (t) {
        t.sealed = true;
    };
    Transaction.prototype.checkConflictsResolved = function () {
        var _this = this;
        this.conflicts = undefined;
        this.changeset.forEach(function (r, h) {
            if (r.determineConflicts()) {
                if (!_this.conflicts)
                    _this.conflicts = [];
                _this.conflicts.push(r);
            }
        });
        return !this.conflicts || this.tryResolveConflicts(this.conflicts);
    };
    Transaction.prototype.tryResolveConflicts = function (conflicts) {
        this._error = this._error || new Error(this.hint + " conflicts with other transactions on: " + Tools.formatConflictsSummary(conflicts));
        return false;
    };
    Transaction.prototype.freezeChangeset = function () {
        this.changeset.forEach(function (r, h) { return r.freezeData(); });
    };
    Transaction.prototype.performCommit = function () {
        var _this = this;
        if (this.changeset.size > 0) {
            this._snapshot = ++Ctx.snapshot;
            Handle.applyChangeset(this.changeset);
            var marker = this.snapshot > 0 ? "╚═══" : "═══";
            Tools.log(37, marker, "v" + this.snapshot, "OK");
            if (this.resultPromise)
                this.resultResolve();
            this.changeset.forEach(function (r, h) { return r.invalidateObservers(_this.refreshing); });
        }
        else if (this.resultPromise) {
            this.resultResolve();
            var marker = this.snapshot > 0 ? "╚═══" : "═══";
            Tools.log(37, marker, "v" + this.snapshot, "OK");
        }
    };
    Transaction.prototype.performDiscard = function () {
        this.changeset.forEach(function (r, h) {
            Tools.log(32, "║", "M", r.hint() + " (" + Object.getOwnPropertyNames(r.changemask).join(", ") + ")");
        });
        if (this.resultPromise)
            this.resultReject(this._error);
        Tools.log(31, "╚═══", "", "" + this._error);
    };
    Transaction.prototype.acquirePromise = function () {
        var _this = this;
        if (!this.resultPromise) {
            this.resultPromise = new Promise(function (resolve, reject) {
                _this.resultResolve = resolve;
                _this.resultReject = reject;
            });
        }
        return this.resultPromise;
    };
    Transaction._acquireSnapshotNumber = function (t) {
        if (t._snapshot === 0) {
            t._snapshot = Ctx.snapshot;
            Tools.log(37, "╔═══", "v" + t.snapshot, "" + t.hint);
        }
        return t._snapshot;
    };
    Transaction._addToChangeset = function (t, handle, record) {
        t.changeset.set(handle, record);
    };
    Transaction._getFromChangeset = function (t, handle) {
        return t.changeset.get(handle);
    };
    Transaction._wrap = function (t, c, increment, decrement, func) {
        var f = c ? c.wrap(func) : func;
        if (increment)
            t.run(function () { return t.pending++; });
        var tran = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return t._run(function () {
                if (decrement)
                    t.pending--;
                return f.apply(void 0, args);
            });
        };
        return tran;
    };
    Transaction.id = 9;
    return Transaction;
}());
exports.Transaction = Transaction;
var StoreParams = (function () {
    function StoreParams() {
    }
    return StoreParams;
}());
exports.StoreParams = StoreParams;
var Store = (function () {
    function Store(params) {
        this.params = params || {};
    }
    Store.dispose = function (obj) {
    };
    return Store;
}());
exports.Store = Store;
var VARIO = Symbol("vario");
var VARIO_VMT = Symbol("vario-vmt");
var Handle = (function () {
    function Handle(store, proxy) {
        this.writable = undefined;
        var data = {};
        this.id = ++Handle.id;
        this.store = store;
        this.proxy = proxy;
        this.committed = new Record(this, undefined, Ctx.zerotran, data);
        var vmt = proxy[VARIO_VMT] || {};
        for (var m in vmt)
            data[m] = new Cache(this.committed, vmt[m], false, 0);
        Object.freeze(data);
    }
    Handle.prototype.getCommitted = function () {
        return this.committed;
    };
    Handle.prototype.getForTran = function (t, c, prop) {
        Transaction._acquireSnapshotNumber(t);
        var result = this.writable;
        if (result && result.transaction !== t) {
            result = Transaction._getFromChangeset(t, this);
            if (result)
                this.writable = result;
        }
        if (!result) {
            result = this.committed;
            while (result && result.transaction.snapshot > t.snapshot) {
                if (result.changemask[prop] && c)
                    c.markDirty(result, prop);
                result = result.previous;
            }
        }
        return result;
    };
    Handle.prototype.getForRead = function (prop) {
        var t = Ctx.transaction;
        var result = t ? this.getForTran(t, Ctx.caching, prop) : this.committed;
        if (!result)
            throw new Error("E607: internal error");
        return result;
    };
    Handle.prototype.acquireForWrite = function (prop) {
        var result = this.tryAcquireForWrite(prop, VARIO);
        if (!result)
            throw new Error("unknown error");
        return result;
    };
    Handle.prototype.tryAcquireForWrite = function (prop, value) {
        var c = Ctx.caching;
        if (value !== VARIO && c && c.owner.handle && c.owner.handle !== this)
            throw new Error("E608: object cannot be changed outside of reaction procedure");
        var t = Ctx.transaction;
        if (!t)
            throw new Error("E609: object cannot be changed outside of transaction");
        var existing = this.getForTran(t, c, prop);
        if (!existing || Tools.notEqual(existing.data[prop], value)) {
            var data = existing ? existing.data : value;
            if (!existing || existing.transaction !== t) {
                data = __assign({}, data);
                existing = new Record(this, this.committed, t, data);
                Transaction._addToChangeset(t, this, existing);
                this.writable = existing;
            }
            existing.changemask[prop] = true;
        }
        else
            existing = undefined;
        return existing;
    };
    Handle.applyChangeset = function (changeset) {
        changeset.forEach(function (record, h) {
            h.committed = record;
            Tools.log(32, "║", "M", record.hint() + ": " + Object.getOwnPropertyNames(record.changemask).join(", "));
        });
    };
    Handle.id = 10;
    return Handle;
}());
var Ctx = (function () {
    function Ctx() {
    }
    Ctx.snapshot = 10;
    Ctx.transaction = undefined;
    Ctx.caching = undefined;
    Ctx.store = new Store({ name: "vario" });
    Ctx.zerotran = new Transaction("notran");
    return Ctx;
}());
var Record = (function () {
    function Record(handle, previous, tran, data) {
        this.handle = handle;
        this.previous = previous;
        this.transaction = tran;
        this.data = data;
        this.changemask = {};
        this.conflictmask = {};
        this.observers = {};
    }
    Record.prototype.freezeData = function () {
        Object.freeze(this.data);
        var affected = this.previous ? this.changemask : this.data;
        for (var prop in affected) {
            var val = this.data[prop];
            if (Array.isArray(val) && !Object.isFrozen(val))
                Tools.freezeArray(val, { object: this.handle.proxy, property: prop });
        }
    };
    Record.prototype.subscribeForPropBeingRead = function (prop, cache) {
        if (cache)
            Tools.link(prop, this, this.observers, cache, cache.observables);
    };
    Record.prototype.invalidateObservers = function (refreshing) {
        var affected = 0;
        for (var prop in this.changemask) {
            var value = this.data[prop];
            if (value instanceof Cache && value.dirty)
                value.tryInvalidateBy(value.dirty, "*", refreshing);
        }
        if (this.previous) {
            var o = this.previous.observers;
            for (var prop in o) {
                if (this.changemask[prop])
                    affected += this.invalidateObserversIfAny(prop, o[prop], refreshing);
                else
                    this.observers[prop] = o[prop];
            }
        }
        return affected;
    };
    Record.prototype.determineConflicts = function () {
        var result = false;
        var committed = this.handle.getCommitted();
        if (committed.transaction.snapshot > this.transaction.snapshot) {
            for (var prop in this.changemask) {
                var rival = committed;
                while (rival && !rival.changemask[prop] && rival.transaction.snapshot > this.transaction.snapshot)
                    rival = rival.previous;
                if (rival && rival.data[prop] !== this.data[prop]) {
                    this.conflictmask[prop] = rival;
                    result = true;
                }
            }
        }
        return result;
    };
    Record.prototype.invalidateObserversIfAny = function (prop, observers, refreshing) {
        var _this = this;
        var affected = 0;
        if (observers)
            observers.forEach(function (x) {
                affected += x.tryInvalidateBy(_this, prop, refreshing);
            });
        return affected;
    };
    Record.prototype.hint = function () {
        return this.handle.proxy.constructor.name + "#" + this.handle.id + "t" + this.transaction.id;
    };
    return Record;
}());
var MethodInfo = (function () {
    function MethodInfo(isTran, name, body) {
        this.isTran = isTran;
        this.isAsync = Tools.isAsync(body);
        this.name = name;
        this.body = body;
        Object.freeze(this);
    }
    return MethodInfo;
}());
var Cache = (function () {
    function Cache(owner, method, keepfresh, margin) {
        this.args = [];
        this.value = undefined;
        this.invalidator = undefined;
        this.dirty = undefined;
        this.error = undefined;
        this.keepfresh = false;
        this.margin = 0;
        this.owner = owner;
        this.method = method;
        this.keepfresh = keepfresh;
        this.margin = margin;
        if (this.method.isTran)
            this.wrapper = this.wrapAsTran();
        else
            this.wrapper = this.wrapAsCache();
        Tools.setHandle(this.wrapper, this);
        this.observables = {};
        this.invalidator = owner;
    }
    Cache.prototype.run = function (func) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var outer = Ctx.caching;
        try {
            Ctx.caching = this;
            return func.apply(void 0, args);
        }
        catch (e) {
            this.error = e;
            throw e;
        }
        finally {
            Ctx.caching = outer;
        }
    };
    Cache.prototype.wrap = function (func) {
        var _this = this;
        var caching = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return _this.run.apply(_this, [func].concat(args));
        };
        return caching;
    };
    Cache.prototype.ensureFresh = function () {
        if ((this.invalidator !== undefined || this.method.isTran) && !this.error)
            if (this.method.isAsync)
                this.wrapper.apply(this, this.args).catch(function (error) { });
            else
                this.wrapper.apply(this, this.args);
    };
    Cache.prototype.tryInvalidateBy = function (invalidator, prop, refreshing) {
        var result = 0;
        if (this.invalidator === undefined && (this.owner.transaction.finished() || this.owner.transaction === Ctx.transaction)) {
            this.invalidator = invalidator;
            if (this.keepfresh && refreshing)
                refreshing.push(this);
            result = 1;
            Tools.log(36, "", this.keepfresh && refreshing ? " ■" : " i", this.hint() + " is invalidated by " + this.invalidator.hint() + "." + prop);
            var owner = this.owner.handle.getCommitted();
            while (owner && owner.data[this.method.name] === this) {
                result += this.owner.invalidateObserversIfAny(this.method.name, owner.observers[this.method.name], refreshing);
                owner = owner.previous;
            }
        }
        return result;
    };
    Cache.prototype.markDirty = function (invalidator, prop) {
        if (!this.dirty) {
            this.dirty = invalidator;
            Tools.log(36, "║", "│ x", this.hint() + " is made dirty by " + invalidator.hint() + "." + prop);
        }
    };
    Cache.prototype.wrapAsTran = function () {
        var _this = this;
        var proxy = this.owner.handle.proxy;
        var invokeTran;
        if (this.method.isAsync)
            invokeTran = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return __awaiter(_this, void 0, void 0, function () {
                    var _this = this;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4, Transaction.runAsync.apply(Transaction, [this.hint(), function () {
                                        var argsx = [];
                                        for (var _i = 0; _i < arguments.length; _i++) {
                                            argsx[_i] = arguments[_i];
                                        }
                                        return __awaiter(_this, void 0, void 0, function () {
                                            var _a, result;
                                            return __generator(this, function (_b) {
                                                switch (_b.label) {
                                                    case 0: return [4, (_a = this.method.body).call.apply(_a, [proxy].concat(argsx))];
                                                    case 1:
                                                        result = _b.sent();
                                                        return [2, result];
                                                }
                                            });
                                        });
                                    }].concat(args))];
                            case 1:
                                _a.sent();
                                return [2];
                        }
                    });
                });
            };
        else
            invokeTran = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return Transaction.run.apply(Transaction, [_this.hint(), function () {
                        var argsx = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            argsx[_i] = arguments[_i];
                        }
                        var _a;
                        return (_a = _this.method.body).call.apply(_a, [proxy].concat(argsx));
                    }].concat(args));
            };
        Tools.setHandle(invokeTran, this);
        return invokeTran;
    };
    Cache.prototype.wrapAsCache = function () {
        var _this = this;
        var self = this;
        var invokeCache;
        if (this.method.isAsync)
            invokeCache = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return __awaiter(_this, void 0, void 0, function () {
                    var c;
                    var _this = this;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                c = self;
                                if (!(c.invalidator !== undefined)) return [3, 2];
                                return [4, Transaction.runAsync.apply(Transaction, [c.hint(), function () {
                                            var argsx = [];
                                            for (var _i = 0; _i < arguments.length; _i++) {
                                                argsx[_i] = arguments[_i];
                                            }
                                            return __awaiter(_this, void 0, void 0, function () {
                                                return __generator(this, function (_a) {
                                                    return [2, c.renewAsync.apply(c, argsx)];
                                                });
                                            });
                                        }].concat(args))];
                            case 1:
                                c = _a.sent();
                                _a.label = 2;
                            case 2:
                                c.owner.subscribeForPropBeingRead(c.method.name, Ctx.caching);
                                return [2, c.value];
                        }
                    });
                });
            };
        else
            invokeCache = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var c = self;
                if (c.invalidator !== undefined) {
                    c = Transaction.run.apply(Transaction, [c.hint(), function () {
                            var argsx = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                argsx[_i] = arguments[_i];
                            }
                            return c.renew.apply(c, argsx);
                        }].concat(args));
                }
                c.owner.subscribeForPropBeingRead(c.method.name, Ctx.caching);
                return c.value;
            };
        return invokeCache;
    };
    Cache.prototype.renew = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var r = this.owner.handle.acquireForWrite(this.method.name);
        var c = r.data[this.method.name];
        if (c.invalidator !== undefined) {
            c = r.data[c.method.name] = new Cache(r, c.method, c.keepfresh, Ctx.caching ? Ctx.caching.margin + 1 : 0);
            c.args = args;
            c.invalidator = undefined;
            c.value = c.run.apply(c, [function () {
                    var argsx = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        argsx[_i] = arguments[_i];
                    }
                    var _a;
                    Tools.log(34, "║", "┌──", c.hint() + " is starting");
                    var result = (_a = c.method.body).call.apply(_a, [c.owner.handle.proxy].concat(argsx));
                    Tools.log(34, "║", "└──", c.hint() + " is finished");
                    return result;
                }].concat(args));
        }
        if (c.error)
            throw c.error;
        return c;
    };
    Cache.prototype.renewAsync = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var r, c, _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        r = this.owner.handle.acquireForWrite(this.method.name);
                        c = r.data[this.method.name];
                        if (!(c.invalidator !== undefined)) return [3, 2];
                        c = r.data[c.method.name] = new Cache(r, c.method, c.keepfresh, Ctx.caching ? Ctx.caching.margin + 1 : 0);
                        c.args = args;
                        c.invalidator = undefined;
                        _a = c;
                        return [4, c.run.apply(c, [function () {
                                    var argsx = [];
                                    for (var _i = 0; _i < arguments.length; _i++) {
                                        argsx[_i] = arguments[_i];
                                    }
                                    return __awaiter(_this, void 0, void 0, function () {
                                        var _a, result;
                                        return __generator(this, function (_b) {
                                            switch (_b.label) {
                                                case 0:
                                                    Tools.log(34, "║", "┌──", c.hint() + " is starting");
                                                    return [4, (_a = c.method.body).call.apply(_a, [c.owner.handle.proxy].concat(argsx))];
                                                case 1:
                                                    result = _b.sent();
                                                    Tools.log(34, "║", "└──", c.hint() + " is finished");
                                                    return [2, result];
                                            }
                                        });
                                    });
                                }].concat(args))];
                    case 1:
                        _a.value = _b.sent();
                        _b.label = 2;
                    case 2:
                        if (c.error)
                            throw c.error;
                        return [2, c];
                }
            });
        });
    };
    Cache.prototype.hint = function () {
        return this.owner.handle.proxy.constructor.name + "#" + this.owner.handle.id + "t" + this.owner.transaction.id + "." + this.method.name;
    };
    return Cache;
}());
var Tools = (function () {
    function Tools() {
    }
    Tools.getHandle = function (obj) {
        return obj[VARIO];
    };
    Tools.setHandle = function (obj, handle) {
        Object.defineProperty(obj, VARIO, { value: handle, configurable: false, enumerable: false });
        return handle;
    };
    Tools.acquireHandle = function (obj, store) {
        if (obj !== Object(obj) || Array.isArray(obj))
            throw new Error("E604: only objects can be registered in vario store");
        var h = Tools.getHandle(obj);
        if (!h) {
            if (Ctx.transaction)
                Transaction._acquireSnapshotNumber(Ctx.transaction);
            h = Tools.setHandle(obj, new Handle(store, obj));
        }
        return h;
    };
    Tools.hookArrayItem = function (array, index) {
        var t = array[index];
        var getter = function () { return t; };
        var setter = function (value) {
            var a = array;
            if (Object.isFrozen(a)) {
                var hp = Tools.getHandle(a);
                a = a.slice();
                hp.object[hp.property] = a;
            }
            a[index] = value;
        };
        var pd = Object.getOwnPropertyDescriptor(array, index);
        Object.defineProperty(array, index, { configurable: true, enumerable: pd ? pd.enumerable : true, get: getter, set: setter });
    };
    Tools.hookArrayMethod = function (array, method) {
        array[method.name] = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var a = array;
            if (Object.isFrozen(a)) {
                var hp = Tools.getHandle(a);
                a = a.slice();
                hp.object[hp.property] = a;
            }
            return method.call.apply(method, [a].concat(args));
        };
    };
    Tools.freezeArray = function (arr, hp) {
        if (Tools.getHandle(arr))
            throw new Error("E610: array cannot be referenced from multiple objects");
        Tools.setHandle(arr, hp);
        for (var item in arr)
            Tools.hookArrayItem(arr, item);
        for (var _i = 0, _a = [arr.push, arr.pop, arr.shift, arr.sort, arr.splice, arr.unshift]; _i < _a.length; _i++) {
            var method = _a[_i];
            Tools.hookArrayMethod(arr, method);
        }
        Object.freeze(arr);
    };
    Tools.notEqual = function (oldValue, newValue) {
        var result;
        if (oldValue instanceof Cache) {
            if (newValue instanceof Function)
                result = oldValue.method.body !== newValue;
            else
                result = true;
        }
        else
            result = newValue !== oldValue;
        return result;
    };
    Tools.formatObservables = function (observer) {
        var observables = [];
        var _loop_1 = function (prop) {
            var t = observer.observables[prop];
            if (t)
                t.forEach(function (r) { return observables.push(r.hint() + "." + prop); });
        };
        for (var prop in observer.observables) {
            _loop_1(prop);
        }
        return observables.join(", ");
    };
    Tools.formatConflictsSummary = function (conflicts) {
        return conflicts.map(function (x) {
            var names = Object.getOwnPropertyNames(x.conflictmask)
                .map(function (prop) { return Tools.formatConflictingProperty(prop, x, x.conflictmask[prop]); })
                .join(", ");
            return "" + names;
        }).join(", ");
    };
    Tools.formatConflictingProperty = function (prop, mine, theirs) {
        return theirs.hint() + "." + prop;
    };
    Tools.link = function (prop, observable, observableMask, observer, observerMask) {
        var observers = observableMask[prop];
        if (!observers)
            observableMask[prop] = observers = new Set();
        observers.add(observer);
        var observables = observerMask[prop];
        if (!observables)
            observerMask[prop] = observables = new Set();
        observables.add(observable);
        Tools.log(34, "║", "│ ∞", observer.owner.hint() + "." + observer.method.name + " reads " + observable.hint() + "." + prop);
    };
    Tools.unlink = function (prop, obj1, mask1, obj2, mask2) {
        mask1[prop].delete(obj2);
        mask2[prop].delete(obj1);
    };
    Tools.dispose = function (obj) {
        throw new Error("not implemented");
    };
    Tools.log = function (color, ctx, op, message) {
        var t = Transaction.current;
        color = 31 + (t ? t.id : 0) % 6;
        ctx = t ? "t" + t.id + " " + ctx : "v" + Ctx.snapshot + " " + ctx;
        var margin = "│ ".repeat(Ctx.caching ? Ctx.caching.margin : 0);
        console.log("\x1b[37m%s\x1b[0m \x1b[" + color + "m%s\x1b[0m \x1b[" + color + "m%s%s\x1b[0m \x1b[" + color + "m%s\x1b[0m", "#vario", ctx, margin, op, message);
    };
    Tools.isAsync = function (func) {
        var string = func.toString().trim();
        return !!(string.match(/^async /) ||
            string.match(/return _ref[^\.]*\.apply/) ||
            string.match(/return __awaiter/));
    };
    Tools.rethrowError = function (error) {
        throw error;
    };
    return Tools;
}());
var originalThen = Promise.prototype.then;
Promise.prototype.then = function (onsuccess, onfailure) {
    var t = Ctx.transaction;
    if (t) {
        if (onsuccess) {
            onsuccess = Transaction._wrap(t, Ctx.caching, true, true, onsuccess);
            onfailure = Transaction._wrap(t, Ctx.caching, false, true, onfailure || Tools.rethrowError);
        }
        else if (onfailure)
            onfailure = Transaction._wrap(t, Ctx.caching, false, false, onfailure);
    }
    return originalThen.call(this, onsuccess, onfailure);
};
function statusof(method) {
    var result = { value: undefined, outdated: false, error: undefined, keepfresh: false };
    var t = Tools.getHandle(method);
    if (t instanceof Cache) {
        t.owner.subscribeForPropBeingRead(t.method.name, Ctx.caching);
        result = { value: t.value, outdated: t.invalidator !== undefined, error: t.error, keepfresh: t.keepfresh };
    }
    return result;
}
exports.statusof = statusof;
function keepfresh(value, method) {
    var args = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        args[_i - 2] = arguments[_i];
    }
    var t = Tools.getHandle(method);
    if (t instanceof Cache) {
        t.args = args;
        t.keepfresh = value;
        if (value)
            t.ensureFresh();
    }
    else
        throw new Error("only cached method can be renewed automatically");
}
exports.keepfresh = keepfresh;
function dispose(obj) {
    return Tools.dispose(obj);
}
exports.dispose = dispose;
exports.transactional = tran;
function tran(target, prop, descriptor) {
    if (prop) {
        if (descriptor)
            return memberDecorator(true, target, prop, descriptor);
        else
            return memberDecorator(false, target, prop);
    }
    else
        return classDecorator(target);
}
exports.tran = tran;
function cache(ctor, prop, descriptor) {
    return memberDecorator(false, ctor, prop, descriptor);
}
exports.cache = cache;
function classDecorator(target) {
    var origCtor = target;
    var newCtor = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return Transaction.run.apply(Transaction, [origCtor.name + ".ctor", function () {
                var argsx = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    argsx[_i] = arguments[_i];
                }
                var ctor = function () { return origCtor.call.apply(origCtor, [this].concat(argsx)); };
                ctor.prototype = origCtor.prototype;
                return new ctor();
            }].concat(args));
    };
    newCtor.prototype = origCtor.prototype;
    return newCtor;
}
function memberDecorator(isTran, proto, prop, pd) {
    var getter = function () {
        var h = Tools.acquireHandle(this, Ctx.store);
        var r = h.getForRead(prop);
        var result = r.data[prop];
        if (result instanceof Cache)
            result = result.wrapper;
        else
            r.subscribeForPropBeingRead(prop, Ctx.caching);
        return result;
    };
    var setter = function (value) {
        var h = Tools.acquireHandle(this, Ctx.store);
        var r = h.tryAcquireForWrite(prop, value);
        if (r)
            r.data[prop] = value;
    };
    if (pd && pd.value) {
        var vmt = proto[VARIO_VMT] || (proto[VARIO_VMT] = {});
        if (!proto.hasOwnProperty(VARIO_VMT))
            vmt = proto[VARIO_VMT] = __assign({}, vmt);
        vmt[prop] = new MethodInfo(isTran, prop, pd.value);
    }
    if (!pd)
        pd = Object.getOwnPropertyDescriptor(proto, prop);
    pd = { configurable: false, enumerable: pd ? pd.enumerable : true, get: getter, set: setter };
    return Object.defineProperty(proto, prop, pd);
}
Ctx.zerotran.commit();
//# sourceMappingURL=vario.js.map